<template src="./edit.htm"></template>

<script>

    import Vue from 'vue';
    import EditInfo from './components/info/EditInfoComponent.vue';
    import EditAttributesComponent from './components/attributes/EditAttributesComponent.vue';
    import EditImagesComponent from './components/images/EditImagesComponent.vue';
    import EditRelatedProductsComponent from './components/related/EditRelatedProductsComponent.vue';

    import { breadcrumbsMixin } from '../../../mixins/breadcrumbsMixin.js';
    import HandleEntityMixin from '../../../mixins/entities/handleEntityMixin.js';
    import GetEntityMixin from '../../../mixins/entities/getEntityMixin.js';
    import HandleProductMixin from '../../mixins/handleProductMixin.js';
    import ValidationErrorsMixin from '../../../mixins/validationErrorsMixin.js';

    Vue.component('edit-info', EditInfo);
    Vue.component('edit-attributes', EditAttributesComponent);
    Vue.component('edit-images', EditImagesComponent);
    Vue.component('edit-related-products', EditRelatedProductsComponent);

    export default {

        mounted() {

            this.getEntityMixin('products', this.$route.params.id, 'setProduct');
        },

        data() {

            return {

            }
        },

        mixins: [
            breadcrumbsMixin,
            HandleEntityMixin,
            GetEntityMixin,
            HandleProductMixin,
            ValidationErrorsMixin
        ],

        methods: {

            /**
             * Update brand from store, and redirect to given action (index, create).
             **/
            updateProduct(action) {

                this.handleEntity('product', action, route('admin.products.update', this.$route.params.id));
            }
        }
    }

</script>